
/******************************************************************************
* MODULE     : conv_template.cc
* DESCRIPTION: Template types
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <quantor.hh>
#include <xtable.hh>
namespace mmx {

void
evaluator_rep::kw_conv_template_1 () {
  CHECK_SYNC (CONV_TEMPLATE);
  evaluate_arg (car(trace)[1], KW_CONV_TEMPLATE_2);
}

void
evaluator_rep::kw_conv_template_2 () {
  CHECK_SYNC (CONV_TEMPLATE);
  // INPUT: (conv_template_2, template, cont, ...)
  value v= as_value (car (rem));
  generic val = v->val;
  generic type= substitute (v->type[2], v->type[1], car(trace)[2]);
  if (is_func (val, MMX_FORALLVAL, 3)) {
    generic old_env= env;
    table xtra= table ();
    generic qt_val= car(trace)[2];
    if (!is_value (qt_val)) qt_val= value (qt_val, ID_CLASS);
    xtra (val[2])= qt_val;
    env= xtable (as_gentable (val[1]), xtra);
    // cout << "Template " << val[2] << " := " << qt_val << lf << indent;
    cur= val[3];
    rem= cons (KW_CONV_TEMPLATE_3, type, old_env, cdr (rem));
    // OUTPUT: (instantiation, conv_template_3, type, old_env, cont, ...)
  }
  else {
    cur= cadr (rem);
    rem= cons (value (val, type), cddr (rem));
    // OUTPUT: (cont, instantiation, ...)
    trace= cdr (trace);
  }
}

void
evaluator_rep::kw_conv_template_3 () {
  // INPUT: (conv_template_3, instantiation, type, old_env, cont, ...)
  env= as_gentable (caddr (rem));
  /*
  if (T (car (rem)) != cadr (rem)) {
    // FIXME: this test fails when converting the empty list [] to List Int
    // this seems OK though, since the type of [] is not magically List Int
    cerr << "expected: " << cadr (rem) << lf;
    cerr << "returned: " << T (car (rem)) << lf;
    error (car (trace), "Type mismatch in template instantiation");
    return;
  }
  */
  cur= cadddr (rem);
  rem= cons (car (rem), cddddr (rem));
  // OUTPUT: (cont, instantiation, ...)
  trace= cdr (trace);
}

} // namespace mmx
