
/******************************************************************************
* MODULE     : conv_unand.cc
* DESCRIPTION: Choose type in overloaded type
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <single.hh>
#include <gentable.hh>
namespace mmx {

void
evaluator_rep::kw_conv_unand_1 () {
  CHECK_SYNC (CONV_UNAND);
  evaluate_arg (car(trace)[1], KW_CONV_UNAND_2);
}

void
evaluator_rep::kw_conv_unand_2 () {
  CHECK_SYNC (CONV_UNAND);
  // INPUT: (conv_unand_2, tuple, cont, ...)
  int   i= as_int (car (trace) [2]);
  value v= as_value (car (rem));
  if (is_func (v->val, MMX_AND)) {
    cur= cadr (rem);
    rem= cons (value (v->val[i], v->type[i]), cddr (rem));
    // OUTPUT: (cont, member, ...)
    trace= cdr (trace);
  }
  else { // delayed evaluation of disambiguated expressions
    list amb= cdr (as_list (v->val));
    gentable old_env= env;
    env= as_gentable (car (amb));
    cur= amb[i];
    rem= cons (KW_CONV_UNAND_3, old_env, cdr (rem));
    // OUTPUT: (delayed_expr, conv_unand_3, old_env, cont, ...)
  }
}

void
evaluator_rep::kw_conv_unand_3 () {
  CHECK_SYNC (CONV_UNAND);
  // INPUT: (conv_unand_3, result, old_env, cont, ...)
  env= as_gentable (cadr (rem));
  cur= caddr (rem);
  rem= cons (car (rem), cdddr (rem));
  // OUTPUT: (cont, result, ...)
  trace= cdr (trace);
}

} // namespace mmx
